clear all
close all
k = 3;
n1 = 10;
n2 = 11;
a1 = 0;
b1 = pi;
x = linspace(a1,b1,n1);
a2 = 0;
b2 = 2*pi;
y = linspace(a2,b2,n2);
f = @(x,y) sin(x).*sin(y); % function in [a1,b1] x [a2,b2]
xx = linspace(0,1,51);
sx = zeros(size(xx));
for i = 1:n1
  sx = sx+(x(i)-a1)/(b1-a1)*B(i,n1-1,k,xx);
end
yy = linspace(0,1,41);
sy = zeros(size(yy));
for j = 1:n2
  sy = sy+(y(j)-a2)/(b2-a2)*B(j,n2-1,k,yy);
end
[X,Y] = ndgrid(x,y);
d = f(X,Y);
[XX,YY] = ndgrid(xx,yy);
s = zeros(size(XX));
for i = 1:n1
  for j = 1:n2
    s = s+d(i,j)*B(i,n1-1,k,XX).*B(j,n2-1,k,YY);
  end
end
% refinement
x = [x(1)*ones(1,k-2),x,x(n1)*ones(1,k-2)];
y = [y(1)*ones(1,k-2),y,y(n2)*ones(1,k-2)];
[X,Y] = ndgrid(x,y);
d = f(X,Y);
level = 3;
for l = 1:level
  m1 = length(x);
  x1 = zeros(1,2*m1-2);
  for mm1 = 2:m1
    x1(2*mm1-3) = x(mm1)/4+3*x(mm1-1)/4;
    x1(2*mm1-2) = 3*x(mm1)/4+x(mm1-1)/4;
  end
  m2 = length(y);
  y1 = zeros(1,2*m2-2);
  for mm2 = 2:m2
    y1(2*mm2-3) = y(mm2)/4+3*y(mm2-1)/4;
    y1(2*mm2-2) = 3*y(mm2)/4+y(mm2-1)/4;
  end
  for mm1 = 2:m1
    for mm2 = 2:m2
      d1(2*mm1-3,2*mm2-3)=(1/16)*d(mm1,mm2)+(3/16)*d(mm1,mm2-1)+...
          (3/16)*d(mm1-1,mm2)+(9/16)*d(mm1-1,mm2-1);
      d1(2*mm1-3,2*mm2-2)=(3/16)*d(mm1,mm2)+(1/16)*d(mm1,mm2-1)+...
          (9/16)*d(mm1-1,mm2)+(3/16)*d(mm1-1,mm2-1);
      d1(2*mm1-2,2*mm2-3)=(3/16)*d(mm1,mm2)+(9/16)*d(mm1,mm2-1)+...
          (1/16)*d(mm1-1,mm2)+(3/16)*d(mm1-1,mm2-1);
      d1(2*mm1-2,2*mm2-2)=(9/16)*d(mm1,mm2)+(3/16)*d(mm1,mm2-1)+...
          (3/16)*d(mm1-1,mm2)+(1/16)*d(mm1-1,mm2-1);
    end
  end
  x = x1;
  y = y1;
  d = d1;
end
[sX,sY] = ndgrid(a1+(b1-a1)*sx,a2+(b2-a2)*sy);
mesh(sX,sY,s)
xlabel('x')
ylabel('y')
[X,Y] = ndgrid(x,y);
hold on
plot3(X(:),Y(:),d(:),'.k')
